/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------*/

// TEST_002:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/

        int randomnumber=-1;

/*================================================================================================================*/
// ************************************** FOUR NATIVES APPEAR ON THIS MAP: ************************************** //
/*================================================================================================================*/

	    int subCiv0=-1;
	    int subCiv1=-1;
	    int subCiv2=-1;
	    int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        int whichVariation = rmRandInt(1,2); 		
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    if (rmAllocateSubCivs(3) == true)
	{
		subCiv0=rmGetCivID("Nootka");
		rmEchoInfo("subCiv0 is nootka "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Nootka");

		subCiv1=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv1 is Iroquois "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Iroquois");

		if(rmRandFloat(0,1) < 0.5)
		{
		subCiv2=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv2 is Iroquois "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Iroquois");
		}
		else 
		{
		subCiv2=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv2 is Iroquois "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Iroquois");
		}

		subCiv3=rmGetCivID("Nootka");
		rmEchoInfo("subCiv3 is Nootka "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Nootka");
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
        int teamOneCount = rmGetNumberPlayersOnTeam(1);	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int playerTiles=25000;
	    
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(638, 638);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    
	    // SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0);

		// SET MAP ELEVATION PARAMETERS:
		//	rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0);
		
		// SET SEA TYPE:
		rmSetSeaType("New England Coast");
	
	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("newengland_grass");
	
	    // TERRAIN INITIALIZATION:
		rmTerrainInitialize("new_england\ground1_ne", 5);
			
	    // SET MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	
	    // SET LIGHTING:
		rmSetLightingSet("new england");
	
	    // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
		
		// CHOOSE THE MERCS:
		chooseMercs();
		
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classSocket");
		rmDefineClass("island");
		rmDefineClass("center");
		rmDefineClass("classTrees");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE THE MAP EDGE CONSTRAINTS: *************************************** // 
/*----------------------------------------------------------------------------------------------------------------*/
           
    //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(35), rmZTilesToFraction(35), 1.0-rmXTilesToFraction(35), 1.0-rmZTilesToFraction(35), 0.01);
    int playerEdgeConstraint=rmCreatePieConstraint("edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
		 
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE CARDINAL DIRECTION CONSTRAINTS: *********************************** //
/*--------------------------------------------------------------------------------------------------------------- //

    int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
    int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
    int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
/*----------------------------------------------------------------------------------------------------------------*/
// *************************************** DEFINE THE PLAYER CONSTRAINTS: *************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    
	int playerConstraint=rmCreateClassDistanceConstraint("stuff avoid players", classPlayer, 15.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close stuff avoid players", classPlayer, 5.0);
	int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff avoid players", classPlayer, 2.0);
	int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stuff avoid players", classPlayer, 25.0);
	int playerFarConstraint=rmCreateClassDistanceConstraint("far stuff avoid players", classPlayer, 50.0);
	int playerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stuff avoid players", classPlayer, 75.0);
				
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE FISHES AVOIDANCE: ***************************** //
/*----------------------------------------------------------------------------------------------------------------*/
 
    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE CENTER AREA: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
    int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
	int centerCloseConstraint=rmCreateClassDistanceConstraint("close stay away from center", rmClassID("center"), 5.0);
	int centerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from center", rmClassID("center"), 2.0);
	int centerMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from center", rmClassID("center"), 25.0);
	int centerFarConstraint=rmCreateClassDistanceConstraint("far stay away from center", rmClassID("center"), 50.0);
    int centerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from center", rmClassID("center"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINTS FOR THE FOREST AVOIDANCE: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

    int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
    
	int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs. forest", rmClassID("classForest"), 5.0);
	int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs. forest", rmClassID("classForest"), 2.0);
	int forestMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs. forest", rmClassID("classForest"), 25.0);
	int forestFarConstraint=rmCreateClassDistanceConstraint("far stuff vs. forest", rmClassID("classForest"), 50.0);
	int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far stuff vs. forest", rmClassID("classForest"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE TREES: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINTS FOR THE RESOURCE AVOIDANCE: **************************** //
/*----------------------------------------------------------------------------------------------------------------*/

   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
// **************************** DEFINE THE CONSTRAINTS FOR THE FASTCOIN AVOIDANCE: ****************************** //   
/*----------------------------------------------------------------------------------------------------------------*/

	int	avoidFastCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
    int avoidCloseFastCoin=rmCreateTypeDistanceConstraint("close stuff avoids coin", "gold", 5.0);
    int avoidVeryCloseFastCoin=rmCreateTypeDistanceConstraint("very close stuff avoids coin", "gold", 2.0);
    int avoidMediumFastCoin=rmCreateTypeDistanceConstraint("medium stuff avoids coin", "gold", 25.0);
    int avoidFarFastCoin=rmCreateTypeDistanceConstraint("far stuff avoids coin", "gold", 50.0);
    int avoidVeryFarFastCoin=rmCreateTypeDistanceConstraint("very far stuff avoids coin", "gold", 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE CONSTRAINTS FOR THE NUGGET: ************************************ //	
/*----------------------------------------------------------------------------------------------------------------*/
	
   int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
   int avoidCloseNugget=rmCreateTypeDistanceConstraint("close stuff avoid nugget", "AbstractNugget", 5.0);
   int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close stuff avoid nugget", "AbstractNugget", 2.0);
   int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium stuff avoid nugget", "AbstractNugget", 25.0);
   int avoidFarNugget=rmCreateTypeDistanceConstraint("far stuff avoid nugget", "AbstractNugget", 50.0);
   int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far stuff avoid nugget", "AbstractNugget", 75.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE CONSTRAINTS FOR THE FRUITS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/		
				
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 15.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 5.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "berrybush", 2.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE ELK AVOIDANCE: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
   
    int avoidElk=rmCreateTypeDistanceConstraint("stuff avoids elk", "elk", 15.0); 
    int avoidCloseElk=rmCreateTypeDistanceConstraint("close stuff avoids elk", "elk", 5.0);  
	int avoidVerycloseElk=rmCreateTypeDistanceConstraint("very close avoids elk", "elk", 2.0);
    int avoidMediumElk=rmCreateTypeDistanceConstraint("medium stuff avoids elk", "elk", 25.0);  
	int avoidFarElk=rmCreateTypeDistanceConstraint("far stuff avoids elk", "elk", 50.0);  
	int avoidVeryFarElk=rmCreateTypeDistanceConstraint("very far stuff avoids elk", "elk", 75.0);  
   
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE MOOSE AVOIDANCE: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/
   
   int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 15.0);
   int avoidCloseMoose=rmCreateTypeDistanceConstraint("close stuff avoids moose", "moose", 5.0);
   int avoidVeryCloseMoose=rmCreateTypeDistanceConstraint("very close stuff avoids moose", "moose", 2.0);
   int avoidMediumMoose=rmCreateTypeDistanceConstraint("medium stuff avoids moose", "moose", 25.0);
   int avoidFarMoose=rmCreateTypeDistanceConstraint("far stuff avoids moose", "moose", 50.0);
   int avoidVeryFarMoose=rmCreateTypeDistanceConstraint("very far stuff avoids moose", "moose", 75.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE DEER AVOIDANCE: ******************************* //
/*----------------------------------------------------------------------------------------------------------------*/
   
   int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
   int avoidCloseDeer=rmCreateTypeDistanceConstraint("close stuff avoids deer", "deer", 5.0);
   int avoidVeryCloseDeer=rmCreateTypeDistanceConstraint("very close stuff avoids deer", "deer", 2.0);
   int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium stuff avoids deer", "deer", 25.0);
   int avoidFarDeer=rmCreateTypeDistanceConstraint("far stuff avoids deer", "deer", 50.0);
   int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far stuff avoids deer", "deer", 75.0);   
   
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE SHEEP AVOIDANCE: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

   int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
   int avoidCloseSheep=rmCreateTypeDistanceConstraint("close stuff avoids sheep", "sheep", 5.0);
   int avoidVeryCloseSheep=rmCreateTypeDistanceConstraint("very close stuff avoids sheep", "sheep", 2.0);
   int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium stuff avoids sheep", "sheep", 25.0);
   int avoidFarSheep=rmCreateTypeDistanceConstraint("far stuff avoids sheep", "sheep", 50.0);
   int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far stuff avoids sheep", "sheep", 75.0);       
   
/*----------------------------------------------------------------------------------------------------------------*/   
// ****************************** DEFINE THE CONSTRAINTS FOR THE IMPASSABLE LAND: ******************************* //   
/*----------------------------------------------------------------------------------------------------------------*/

    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff avoid impassable land", "Land", false, 15.0);
    int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close stuff avoid impassable land", "Land", false, 5.0);
    int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close stuff avoid impassable land", "Land", false, 2.0);
    int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium stuff avoid impassable land", "Land", false, 25.0);
    int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far stuff avoid impassable land", "Land", false, 50.0);
    int avoidVeryFarImpassableLand=rmCreateTerrainDistanceConstraint("very far stuff avoid impassable land", "Land", false, 75.0);
    
	
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);

/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS TO AVOID WATER: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/

    int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water medium 8", "Land", false, 8.0);
    int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water medium 10", "Land", false, 10.0);
    int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium 12", "Land", false, 12.0);
    int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water medium 15", "Land", false, 15.0);
    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
   
/*----------------------------------------------------------------------------------------------------------------*/   
// *********************** DEFINE THE NEW EXTRA STUFFS FOR THE WATER SPAWN POINT AVOIDANCE: ********************* //
/*----------------------------------------------------------------------------------------------------------------*/
   
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 10);
	int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
	//int flagBoxConstraint=rmCreateBoxConstraint("flag area", 0, 0.5, 0.6, 0.9, 0.0);  
   
/*----------------------------------------------------------------------------------------------------------------*/   
   
   int ferryOnShore=rmCreateTerrainMaxDistanceConstraint("ferry v. water", "water", true, 12.0);
   int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
   int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE THE TRADE ROUTE AVOIDANCE: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/

   	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
	int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close trade route", 2.0);
	int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("medium trade route", 25.0);
	int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far trade route", 50.0);
	int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far trade route", 75.0);
	
	int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** DEFINE THE SOCKETS AVOIDANCE: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	
    int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 15.0);
	int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 5.0);
	int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("classSocket"), 2.0);
	int avoidMediumSocket = rmCreateClassDistanceConstraint("medium avoid socket", rmClassID("classSocket"), 25.0);
	int avoidFarSocket = rmCreateClassDistanceConstraint("far avoid socket", rmClassID("classSocket"), 50.0);
	int avoidVeryFarSocket = rmCreateClassDistanceConstraint("very far avoid socket", rmClassID("classSocket"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINTS FOR THE IMPORTANT ITEM: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	  
    int avoidImportantItem = rmCreateClassDistanceConstraint("stuff avoid important Item", rmClassID("importantItem"), 15.0);
    int avoidCloseImportantItem = rmCreateClassDistanceConstraint("close stuff avoid important Item", rmClassID("importantItem"), 5.0);
    int avoidVeryCloseImportantItem = rmCreateClassDistanceConstraint("very close stuff avoid important Item", rmClassID("importantItem"), 2.0);
    int avoidMediumImportantItem = rmCreateClassDistanceConstraint("medium stuff avoid important Item", rmClassID("importantItem"), 25.0);
    int avoidFarImportantItem = rmCreateClassDistanceConstraint("far stuff avoid important Item", rmClassID("importantItem"), 50.0);
    int avoidVeryFarImportantItem = rmCreateClassDistanceConstraint("very far stuff avoid important Item", rmClassID("importantItem"), 75.0);
   
/*----------------------------------------------------------------------------------------------------------------*/    
// ********************************* DEFINE THE CONSTRAINTS FOR THE DECORATIONS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINTS FOR THE STARTING UNITS: ******************************* //
/*----------------------------------------------------------------------------------------------------------------*/

    int avoidStartingUnits=rmCreateClassDistanceConstraint("stuff avoid starting units", rmClassID("startingUnit"), 15.0);
    int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close stuff avoid starting units", rmClassID("startingUnit"), 5.0);
    int avoidVeryCloseStartingUnits=rmCreateClassDistanceConstraint("very close stuff avoid starting units", rmClassID("startingUnit"), 2.0);
    int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium stuff avoid starting units", rmClassID("startingUnit"), 25.0);
    int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far stuff avoid starting units", rmClassID("startingUnit"), 50.0);
    int avoidVeryFarStartingUnits=rmCreateClassDistanceConstraint("very far stuff avoid starting units", rmClassID("startingUnit"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/	
	
    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

    // ships vs. ships
    int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/

        // DEFINE SOME OBJECTS:
        // THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER:

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/ 
// ************************************* DEFINE AND PLACE THE MAIN RIVER: *************************************** //    
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int wayneRiver = -1;
	    
		if ( cNumberNonGaiaPlayers < 4 )
{
		//wayneRiver = rmRiverCreate(-1, "New England Coast", 5, 5, 22.5, 22.5);
		
		if ( whichVariation == 1 )
	{	
		wayneRiver = rmRiverCreate(-1, "saguenay lake", 5, 5, 22.5, 22.5);
	}	
		else
	{	
		wayneRiver = rmRiverCreate(-1, "new england lake", 5, 5, 22.5, 22.5);
	}	
		
}
	    else
{
		//wayneRiver = rmRiverCreate(-1, "New England Coast", 5, 5, 22.5, 22.5);
		
		if ( whichVariation == 1 )
	{	
		wayneRiver = rmRiverCreate(-1, "saguenay lake", 5, 5, 22.5, 22.5);
	}
        else
    {
        wayneRiver = rmRiverCreate(-1, "new england lake", 5, 5, 22.5, 22.5);
	}	
}
	   
	    rmRiverSetConnections(wayneRiver, 0.3, 0.1, 0.9, 0.7);
	    
		// rmRiverSetShallowRadius(wayneRiver, 6);
	    // rmRiverAddShallow(wayneRiver, rmRandFloat(0.5, 0.5));
		// rmRiverAddShallow(wayneRiver, 0.5); // ADDED BY ME:
        
		rmRiverBuild(wayneRiver);
        rmRiverReveal(wayneRiver, 2); 
		
/*----------------------------------------------------------------------------------------------------------------*/		

	// On FFA maps, do not build the other rivers.
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    if ( cNumberTeams == 2 )
{
		// DEFINE AND CONNECT COLUMBIA RIVER TO WAYNE RIVER:
		
		//int columbiaRiver = rmRiverCreate(-1, "New England Coast", 6, 6, 12, 12); // added by me...
		
		if ( whichVariation == 1 )
	{	
		int columbiaRiver = rmRiverCreate(-1, "saguenay lake", 6, 6, 12, 12); // added by me...
	}	
		else
	{	
		columbiaRiver = rmRiverCreate(-1, "new england lake", 6, 6, 12, 12); // added by me...
	}
		
		//rmRiverConnectRiver(source river, dest river, float pct, float x2, float z2)
		  rmRiverConnectRiver(columbiaRiver, wayneRiver, 0.50, 0.35, 0.65);
				
		rmRiverSetShallowRadius(columbiaRiver, 10);
        rmRiverAddShallow(columbiaRiver, 0.5);
		
		rmRiverBuild(columbiaRiver);
		
/*----------------------------------------------------------------------------------------------------------------*/		
// ********************************** TWO TRIBUTARIES OFF THE COLUMBIA RIVER: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/

		// THE RIVER BRANCH NORTH:
		//int riverBranchNorth = rmRiverCreate(-1, "New England Coast", 4, 10, 12, 12);
		
		if ( whichVariation == 1 )
	{	
		int riverBranchNorth = rmRiverCreate(-1, "saguenay lake", 4, 10, 12, 12);
	}	
		else
	{	
		riverBranchNorth = rmRiverCreate(-1, "new england lake", 4, 10, 12, 12);
	}	
		
		rmRiverConnectRiver(riverBranchNorth, columbiaRiver, 0.0, 0.50, 1.0);
		rmRiverSetShallowRadius(riverBranchNorth, 8);
		rmRiverAddShallow(riverBranchNorth, 0.5);
		rmRiverBuild(riverBranchNorth);

		// THE RIVER BRANCH SOUTH:
		//int riverBranchSouth = rmRiverCreate(-1, "New England Coast", 4, 10, 12, 12);
		
		if ( whichVariation == 1 )
	{	
		int riverBranchSouth = rmRiverCreate(-1, "saguenay lake", 4, 10, 12, 12);
	}	
		else
	{	
		riverBranchSouth = rmRiverCreate(-1, "new england lake", 4, 10, 12, 12);
	}	
		
		rmRiverConnectRiver(riverBranchSouth, columbiaRiver, 0.0, 0.0, 0.50);
		rmRiverSetShallowRadius(riverBranchSouth, 8);
		rmRiverAddShallow(riverBranchSouth, 0.5);
		rmRiverBuild(riverBranchSouth);
		

		randomnumber=rmRandInt(1, 100);
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************** BUILD 4 INVISIBLE ISLAND AREAS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NORTH ISLAND: 		
		int northIslandID=rmCreateArea("The North Island 1");
        rmSetAreaSize(northIslandID, 0.165, 0.165);
		rmAddAreaInfluenceSegment(northIslandID, 0.75, 0.90, 0.55, 0.70);
        rmSetAreaLocation(northIslandID, 0.625, 0.775);
		rmSetAreaWarnFailure(northIslandID, false);
		rmSetAreaCoherence(northIslandID, 1.0);
        rmAddAreaToClass(northIslandID, rmClassID("island"));
		//rmSetAreaMix(northIslandID, "rockies_snow");
        rmBuildArea(northIslandID);

        int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);
				
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE AND PLACE SOUTH ISLAND: 		
		int southIslandID=rmCreateArea("The South Island");
        rmSetAreaSize(southIslandID, 0.190, 0.190);
		rmAddAreaInfluenceSegment(southIslandID, 0.10, 0.25, 0.275, 0.425);
        rmSetAreaLocation(southIslandID, 0.225, 0.375);
		rmSetAreaWarnFailure(southIslandID, false);
		rmSetAreaCoherence(southIslandID, 1.0);
        rmAddAreaToClass(southIslandID, rmClassID("center"));
		//rmSetAreaMix(southIslandID, "rockies_snow");
        rmBuildArea(southIslandID);

        int southIslandConstraint=rmCreateAreaConstraint("south island", southIslandID);			
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE EAST ISLAND 3: 		
		int eastIslandID=rmCreateArea("The East Island");
        rmSetAreaSize(eastIslandID, 0.175, 0.175);
		rmAddAreaInfluenceSegment(eastIslandID, 0.50, 0.0, 1.0, 0.50);
        rmSetAreaLocation(eastIslandID, 0.75, 0.25);
		rmSetAreaWarnFailure(eastIslandID, false);
		rmSetAreaCoherence(eastIslandID, 1.0);
        rmAddAreaToClass(eastIslandID, rmClassID("island"));
		//rmSetAreaMix(eastIslandID, "rockies_snow");
        rmBuildArea(eastIslandID);

        int eastIslandConstraint=rmCreateAreaConstraint("East Island", eastIslandID);			
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE WEST ISLAND: 		
		int westIslandID=rmCreateArea("The West Island");
        rmSetAreaSize(westIslandID, 0.125, 0.125);
		rmAddAreaInfluenceSegment(westIslandID, 0.050, 0.65, 0.35, 0.95);
        rmSetAreaLocation(westIslandID, 0.20, 0.80);
		rmSetAreaWarnFailure(westIslandID, false);
		rmSetAreaCoherence(westIslandID, 1.0);
        rmAddAreaToClass(westIslandID, rmClassID("Island"));
		//rmSetAreaMix(westIslandID, "rockies_snow");
        rmBuildArea(westIslandID);

        int westIslandConstraint=rmCreateAreaConstraint("West Island", westIslandID);	  		
		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// **************************************** SET UP THE PLAYER LOCATIONS: **************************************** //
/*================================================================================================================*/
		
		if ( whichVariation == 1 )
   {
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.625, 0.875, 0.725, 0.775, 0.0, 0.0);
		rmSetPlacementTeam(1);
	   	rmPlacePlayersLine(0.225, 0.275, 0.125, 0.375, 0.0, 0.0);
   }
        else
   {
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.225, 0.275, 0.125, 0.375, 0.0, 0.0);
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.625, 0.875, 0.725, 0.775, 0.0, 0.0);
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1250);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
   }
        // Build the areas.
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE TRADE ROUTE AND THE SOCKETS: ***************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);

	    int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.975, 0.475);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.525, 0.025);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute1ID, 0.8, 0.6, 6, 8);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute1ID, 1.0, 1.0, 6, 8);

	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.025);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVES TRIBES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
        int IroquoisVillageType = -1;

	    if (subCiv1 == rmGetCivID("Iroquois"))
   {  
		int IroquoisVillage2ID = -1;
		IroquoisVillageType = rmRandInt(1,5);
		IroquoisVillage2ID = rmCreateGrouping("Iroquois village 2", "native Iroquois village "+IroquoisVillageType);
		rmSetGroupingMinDistance(IroquoisVillage2ID, 0.0);
		rmSetGroupingMaxDistance(IroquoisVillage2ID, 0.0);
		rmAddGroupingToClass(IroquoisVillage2ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(IroquoisVillage2ID, avoidTradeRoute);
		rmAddGroupingConstraint(IroquoisVillage2ID, avoidSocket);
		rmAddGroupingConstraint(IroquoisVillage2ID, avoidImportantItem);
		if ( cNumberTeams == 2 )
		{
			rmPlaceGroupingAtLoc(IroquoisVillage2ID, 0, 0.070, 0.675);
		}
		else
		{
			rmPlaceGroupingAtLoc(IroquoisVillage2ID, 0, 0.325, 0.930);
		}
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv2 == rmGetCivID("Iroquois"))
   {  
		int IroquoisVillage3ID = -1;
		IroquoisVillageType = rmRandInt(1,5);
		IroquoisVillage3ID = rmCreateGrouping("Iroquois village 3", "native Iroquois village "+IroquoisVillageType);
		rmSetGroupingMinDistance(IroquoisVillage3ID, 0.0);
		rmSetGroupingMaxDistance(IroquoisVillage3ID, 0.0);
		rmAddGroupingToClass(IroquoisVillage3ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(IroquoisVillage3ID, avoidTradeRoute);
		rmAddGroupingConstraint(IroquoisVillage3ID, avoidSocket);
		rmAddGroupingConstraint(IroquoisVillage3ID, avoidImportantItem);
		if ( cNumberTeams == 2 )
		{
			rmPlaceGroupingAtLoc(IroquoisVillage3ID, 0, 0.325, 0.930);
		}
		else
		{
			rmPlaceGroupingAtLoc(IroquoisVillage3ID, 0, 0.070, 0.675);
		}
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("Nootka"))
   {  
		int nootkaVillage4ID = -1;
		int nootkaVillageType = rmRandInt(1,5);
		nootkaVillage4ID = rmCreateGrouping("nootka village 4", "native nootka village "+nootkaVillageType);
		rmSetGroupingMinDistance(nootkaVillage4ID, 0.0);
		rmSetGroupingMaxDistance(nootkaVillage4ID, 0.0);
		rmAddGroupingToClass(nootkaVillage4ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(nootkaVillage4ID, avoidTradeRoute);
		rmAddGroupingConstraint(nootkaVillage4ID, avoidSocket);
		rmAddGroupingConstraint(nootkaVillage4ID, avoidImportantItem);
		// Do not place this village in FFA placement
		if ( cNumberTeams == 2 )
		{
			rmPlaceGroupingAtLoc(nootkaVillage4ID, 0, 0.25, 0.75);
		}
   }
 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.625);
/*================================================================================================================*/
// ****************** DEFINE THE STARTING UNITS AND STARTING TCID AND THE STARTING RESOURCES : ****************** // 
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS:
		// STARTING UNIT PLACEMENT - THIS CAN MOVE MORE IN WEIRD CONFIGURATIONS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    if (( teamZeroCount >= teamOneCount * 2 ) || ( teamOneCount >= teamZeroCount * 2 ))
	{
		rmSetObjectDefMaxDistance(startingUnits, 20.0);
	}
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidWater8);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    if (( teamZeroCount >= teamOneCount * 2 ) || ( teamOneCount >= teamZeroCount * 2 ))
	{
		rmSetObjectDefMinDistance(startingTCID, 0.0);
		rmSetObjectDefMaxDistance(startingTCID, 10.0);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakes", 1, 0.0);
	}	
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);

	    // DEFINE THE STARTING DEERS:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 15.0);
		rmAddObjectDefToClass(StartDeerID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartDeerID, avoidCloseStartingUnits);
		
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
		rmAddObjectDefToClass(StartBerryBushID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(StartBerryBushID, avoidCloseStartingUnits);

        // VARIABLES FOR THE PLAYER GOLD:
		int silverID = -1;
	    int silverType = rmRandInt(1,10);
	    int playerGoldID = -1;

	    // VARIABLE FOR THE WATER FLAG:
		int waterFlagID = -1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******************* PLACE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ******************* //	
/*================================================================================================================*/

	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING UNITS AND STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		// DEFINE THE PLAYER GOLD:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
	}
        else
    {
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
    }		
		
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidCloseStartingUnits);
		rmAddObjectDefConstraint(playerGoldID, avoidWater8);
		rmAddObjectDefConstraint(playerGoldID, avoidMediumFastCoin);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		// rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		//rmAddClosestPointConstraint(flagBoxConstraint);		
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FAST COIN: **************************************** //   
/*================================================================================================================*/

        silverID = -1;
	    silverType = rmRandInt(1,10);
	    int silverCount = (cNumberNonGaiaPlayers*5);
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,1);
		silverID = rmCreateObjectDef("silver "+i);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
	}
        else
    {
	    rmAddObjectDefItem(silverID, "minegold", 1, 0.0);
    }		
	
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidFarFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidImportantItem);
		rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
		rmAddObjectDefConstraint(silverID, avoidWater15);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, playerConstraint);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   } 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FOREST: **************************************** //
/*================================================================================================================*/

	    int forestTreeID = 0;
		
		if (cNumberNonGaiaPlayers<=2)
		int numTries=16*cNumberNonGaiaPlayers;
		else
		numTries=8*cNumberNonGaiaPlayers;
        
		//int numTries=8*cNumberNonGaiaPlayers;
        
		int failCount=0;
        int whichForest=-1;
        for (i=0; <numTries)
{   
        int forest=rmCreateArea("forest "+i);
		whichForest=rmRandInt(1, 2);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(300));
        if ( whichForest == 1 )
		{
		rmSetAreaForestType(forest, "new england forest");
		}
		else
		{
		rmSetAreaForestType(forest, "great lakes forest");
		}
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.4);
        rmSetAreaForestUnderbrush(forest, 0.8);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestMediumConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidWater15);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidFastCoin);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
        rmAddAreaConstraint(forest, avoidCloseImpassableLand); 
        rmAddAreaConstraint(forest, avoidTradeRoute);
        rmAddAreaConstraint(forest, avoidSocket); 		
		rmAddAreaConstraint(forest, playerConstraint); 
        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
         else
            failCount=0; 
} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/

	    int nuggetID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nuggetID, northIslandConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, forestConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidWater20);
	    rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
	    
		rmSetNuggetDifficulty(1, 2);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget2ID, southIslandConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidWater20);
	    rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
	    
		rmSetNuggetDifficulty(1, 2);
	    rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE ELK: ****************************************** //	
/*================================================================================================================*/

	    int deerID=rmCreateObjectDef("The Deer Herd 0");
	    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deerID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deerID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deerID, 0.0);
	    rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(deerID, avoidAll);
		rmAddObjectDefConstraint(deerID, avoidNugget);
		rmAddObjectDefConstraint(deerID, playerEdgeConstraint);
		rmAddObjectDefConstraint(deerID, avoidWater15);
		rmAddObjectDefConstraint(deerID, northIslandConstraint);
	    rmAddObjectDefConstraint(deerID, avoidFarDeer);
	    rmAddObjectDefConstraint(deerID, avoidImpassableLand);
	    rmAddObjectDefConstraint(deerID, playerConstraint);
	    
		rmSetObjectDefCreateHerd(deerID, true);
	    rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herd 2");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deer2ID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deer2ID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(deer2ID, avoidAll);
		rmAddObjectDefConstraint(deer2ID, avoidNugget);
		rmAddObjectDefConstraint(deer2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidWater15);
		rmAddObjectDefConstraint(deer2ID, southIslandConstraint);
	    rmAddObjectDefConstraint(deer2ID, avoidFarDeer);
	    rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(deer2ID, playerConstraint);
	    
		rmSetObjectDefCreateHerd(deer2ID, true);
	    rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOOSES: ***************************************** //	
/*================================================================================================================*/
/*
	    int mooseID=rmCreateObjectDef("moose herd 1");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(mooseID, "moose", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(mooseID, "moose", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(mooseID, 0.0);
	    rmSetObjectDefMaxDistance(mooseID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(mooseID, avoidAll);
		rmAddObjectDefConstraint(mooseID, northIslandConstraint);
	    rmAddObjectDefConstraint(mooseID, avoidFarMoose);
	    rmAddObjectDefConstraint(mooseID, avoidImpassableLand);
		rmAddObjectDefConstraint(mooseID, avoidWater15);
	    rmAddObjectDefConstraint(mooseID, playerConstraint);
	    
		rmSetObjectDefCreateHerd(mooseID, true);
	    rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
*/		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TWO EXTRA MOOSE HERDS ON THE "WESTERN" HALF OF THE MAP:
	    int mooseID2=rmCreateObjectDef("moose herd east");
	    rmAddObjectDefItem(mooseID2, "moose", rmRandInt(5,7), 10.0);
	    rmSetObjectDefMinDistance(mooseID2, 0.0);
	    rmSetObjectDefMaxDistance(mooseID2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(mooseID2, avoidAll);
		rmAddObjectDefConstraint(mooseID2, playerEdgeConstraint);
		rmAddObjectDefConstraint(mooseID2, avoidWater15);
	    rmAddObjectDefConstraint(mooseID2, avoidVeryFarMoose);
		rmAddObjectDefConstraint(mooseID2, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(mooseID2, avoidCloseSocket);
	    rmAddObjectDefConstraint(mooseID2, eastIslandConstraint);
	    rmAddObjectDefConstraint(mooseID2, avoidImpassableLand);
	    rmSetObjectDefCreateHerd(mooseID2, true);
	    rmPlaceObjectDefAtLoc(mooseID2, 0, 0.5, 0.5, 2);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************** HIGH-LEVEL REWARD NUGGETS ON THE EASTERN HALF OF THE MAP: ************************* //
/*================================================================================================================*/

	    int nuggetWestID= rmCreateObjectDef("nugget west"); 
	    rmAddObjectDefItem(nuggetWestID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetWestID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetWestID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetWestID, avoidVeryFarNugget);
		rmAddObjectDefConstraint(nuggetWestID, avoidWater15);
		rmAddObjectDefConstraint(nuggetWestID, avoidAll);
		rmAddObjectDefConstraint(nuggetWestID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nuggetWestID, avoidCloseMoose);
		rmAddObjectDefConstraint(nuggetWestID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(nuggetWestID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggetWestID, eastIslandConstraint);
	    rmAddObjectDefConstraint(nuggetWestID, circleConstraint);
  	    rmAddObjectDefConstraint(nuggetWestID, avoidImpassableLand);
	    rmSetNuggetDifficulty(3, 4);
	    rmPlaceObjectDefAtLoc(nuggetWestID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE WESTERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, westIslandConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidFastCoin);
		rmAddObjectDefConstraint(BerriesID, avoidImportantItem);
		rmAddObjectDefConstraint(BerriesID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries2ID, eastIslandConstraint);
        rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidFastCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidImportantItem);
		rmAddObjectDefConstraint(Berries2ID, avoidMoose);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(Berries2ID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries3ID=rmCreateObjectDef("The Berries 3");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(Berries3ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries3ID, southIslandConstraint);
        rmAddObjectDefConstraint(Berries3ID, avoidAll);
		rmAddObjectDefConstraint(Berries3ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidFastCoin);
		rmAddObjectDefConstraint(Berries3ID, playerConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(Berries3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);	

/*---------------------------------------------------------------------------------------------------------------*/
     
        // THE NORTHERN BERRYBUSH:
		int Berries4ID=rmCreateObjectDef("The Berries 4");
        rmAddObjectDefItem(Berries4ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries4ID, 0.0);
        rmSetObjectDefMaxDistance(Berries4ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(Berries4ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries4ID, northIslandConstraint);
        rmAddObjectDefConstraint(Berries4ID, avoidAll);
		rmAddObjectDefConstraint(Berries4ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidFastCoin);
		rmAddObjectDefConstraint(Berries4ID, playerConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(Berries4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/

        int deer1ID=rmCreateObjectDef("The Deer herds 1");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deer1ID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deer1ID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(deer1ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(deer1ID, avoidAll);
		rmAddObjectDefConstraint(deer1ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(deer1ID, avoidImportantItem);
		rmAddObjectDefConstraint(deer1ID, avoidFastCoin);
		rmAddObjectDefConstraint(deer1ID, westIslandConstraint);
		rmAddObjectDefConstraint(deer1ID, avoidFruits);
		rmAddObjectDefConstraint(deer1ID, playerConstraint);
	    rmAddObjectDefConstraint(deer1ID, avoidVeryFarDeer);
	    rmAddObjectDefConstraint(deer1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(deer1ID, avoidWater15);
	    
	    rmSetObjectDefCreateHerd(deer1ID, true);
	    rmPlaceObjectDefAtLoc(deer1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SHEEP HERDS: **************************************** //
/*================================================================================================================*/

        int sheep1ID=rmCreateObjectDef("The Sheep herds 1");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep1ID, avoidAll);
		rmAddObjectDefConstraint(sheep1ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep1ID, eastIslandConstraint);
		rmAddObjectDefConstraint(sheep1ID, avoidMediumMoose);
		rmAddObjectDefConstraint(sheep1ID, forestConstraint);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseSocket);
		rmAddObjectDefConstraint(sheep1ID, avoidNugget);
		rmAddObjectDefConstraint(sheep1ID, avoidFastCoin);
		rmAddObjectDefConstraint(sheep1ID, avoidFruits);
		rmAddObjectDefConstraint(sheep1ID, playerConstraint);
	    rmAddObjectDefConstraint(sheep1ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep1ID, avoidWater15);
	    
	    rmSetObjectDefCreateHerd(sheep1ID, true);
	    rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		

/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE 4 ISLANDS:
		int randomTreeID=rmCreateObjectDef("North Random Trees");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(randomTreeID, "TreeNewEngland", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(randomTreeID, "TreeGreatLakes", 1, 0.0);
	}	
		
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidWater8);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFastCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 60*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);			
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHSALMON: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int fishID=rmCreateObjectDef("fish");
	    rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);		
	    		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
		
		
		
		
		
		
		
		
		
		
		







